// D64HDblBufWaveDlg.cpp : implementation file
//

#include "stdafx.h"
#include "math.h"
#include "D64HDblBufWave.h"
#include "D64HDblBufWaveDlg.h"

#define maximum_fifo_loop_count 2048

#ifndef   M_PI
#define   M_PI     3.14159265359
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CRect plotRect;

#define D64H_HALF_BUFFER_CHECK_TIMER 1

#ifdef _SELF_OUTPUT_
ULONG DoBuf[10240];
BOOLEAN bOutStopped;
ULONG out_count;
#endif
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD64HDblBufWaveDlg dialog

CD64HDblBufWaveDlg::CD64HDblBufWaveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD64HDblBufWaveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD64HDblBufWaveDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

 	OnBrush = OffBrush = NULL;

	n_PlotWidth = -1;
	n_PlotHeight = -1;

	min_val = 0x00;
	max_val = 0xFFFFFFFF;

	m_bCardID = INVALID_CARD_ID;

	m_fSampleRate = 100000.0; // 100KHz
	m_dwDISamples = 10240;
	m_dwDIBufLen = 0;
	m_pDIAddr = NULL;

	m_nTimer = -1;
	m_nTimer2 = -1;

#ifdef _SELF_OUTPUT_
    for (int i=0; i<10240; i++)
       DoBuf[i] = (U32)(sin((double)i/1024*M_PI)*0x7FFFFFFF)+0x80000000;
#endif
}

void CD64HDblBufWaveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD64HDblBufWaveDlg)
	DDX_Control(pDX, IDC_COMBO_CARDID, m_cbCardID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD64HDblBufWaveDlg, CDialog)
	//{{AFX_MSG_MAP(CD64HDblBufWaveDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_VSCROLL()
	ON_CBN_SELCHANGE(IDC_COMBO_CARDID, OnCardIDSelchange)
	ON_BN_CLICKED(IDC_BT_START, OnStart)
	ON_BN_CLICKED(IDC_BT_STOP, OnStop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD64HDblBufWaveDlg message handlers

BOOL CD64HDblBufWaveDlg::OnInitDialog()
{
	short wCardNum, nErrCode, i;
	BYTE bCardID;
	CString strTemp;
	U32 dwBufLen;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	x_divider = 5; y_divider = 2;	

	OnBrush = CreateSolidBrush( RGB(255,0,0) );
	OffBrush = CreateSolidBrush( RGB(125,0,0) );

	RedPen.CreatePen( PS_SOLID, 1, RGB(255,0,0));
	GreenPen.CreatePen( PS_SOLID, 1, RGB(0,255,0));	

	if(	n_PlotWidth == -1 && n_PlotHeight == -1 )
	{
		((CWnd*)GetDlgItem(IDC_STATIC_DRAW))->GetWindowRect(&plotRect);
		ScreenToClient(&plotRect);

		n_PlotWidth = min( plotRect.Width(), 512);
		n_PlotHeight = plotRect.Height() - 10;
#ifdef DEBUG
		TRACE( (TEXT("[pcid64h_dma: n_PlotWidth: %d  n_PlotHeight: %d ]\r\n"), n_PlotWidth, n_PlotHeight) );
#endif
	}

	// set the default SampleRate
	SetDlgItemInt( IDC_EDIT_SAMPLE_RATE, (UINT)(m_fSampleRate/1000) );

	// Set the default DI Sample
	SetDlgItemInt( IDC_EDIT_SAMPLE, (UINT)(m_dwDISamples) );


	nErrCode = d64h_scan( &wCardNum, NULL );

    if( nErrCode == SUCCESS_NO_ERROR )
    {
		// extract the active pci-d64hu
		for (i=0; i<wCardNum; i++) 
		{
			nErrCode = d64h_cardinfo_get( i, &bCardID );
			
			if( nErrCode == SUCCESS_NO_ERROR)
			{
				if( i==0 )
				{
					nErrCode = d64h_open( bCardID );
					if( nErrCode == SUCCESS_NO_ERROR )
					{
						nErrCode = d64h_di_available_memory( bCardID, &dwBufLen );
						if( nErrCode == SUCCESS_NO_ERROR )
						{
							m_dwDIBufLen = ( dwBufLen * 1024 );
						}

						m_bCardID = bCardID;
						GetDlgItem( IDC_BT_START )->EnableWindow( TRUE );
						GetDlgItem( IDC_BT_STOP )->EnableWindow( TRUE );

					}
				}

				strTemp.Format( TEXT("%d"), bCardID );

				m_cbCardID.AddString( strTemp );
			}
		}

		m_cbCardID.SetCurSel( 0 );
		
    }	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CD64HDblBufWaveDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CD64HDblBufWaveDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		redraw_display_area();
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CD64HDblBufWaveDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CD64HDblBufWaveDlg::redraw_display_area()
{
	CPen *oldPen;

	int oldMode;
	COLORREF oldColor;

	CString y_lable;

	CPen minor_tick( PS_SOLID,1,RGB(132,130,132) );
//		CPen y_grid( PS_SOLID,1,RGB(206,203,132) );

	int i, x_intv, y_intv;
//		long total_sec;

	CClientDC dc_plot(this);

	// draw the base-line for x-y axises
	oldPen = (CPen *)dc_plot.SelectStockObject(BLACK_PEN);

	// redraw the background
	dc_plot.FillSolidRect( plotRect, RGB(0,0,0) );

	// Re-Draw the AREA for Y-Lable
	{
		CBrush DIALOG_BRUSH;
		CRect redraw_area, full_client;

		GetClientRect(&full_client);
		ScreenToClient(&full_client);

		redraw_area.left = full_client.left;
		redraw_area.top = plotRect.top - 5;
		redraw_area.right = plotRect.left - 3;
		redraw_area.bottom = plotRect.bottom + 10;

		DIALOG_BRUSH.CreateSysColorBrush( COLOR_3DFACE );

		dc_plot.FillRect( redraw_area, &DIALOG_BRUSH );

		DIALOG_BRUSH.DeleteObject();
	}

	// ReDraw the Tick
	
	dc_plot.MoveTo( plotRect.left - 3, plotRect.top );
	dc_plot.LineTo( plotRect.left - 3, plotRect.bottom );

	// calculate the interval for tick/grid
	y_intv = (plotRect.Height() - 10) /y_divider;
	x_intv = plotRect.Width()/x_divider;


	// set the color for tick
	oldColor = dc_plot.SetTextColor( RGB(0,0,0) );
	oldMode = dc_plot.SetBkMode( TRANSPARENT );

	for( i=0; i<= y_divider; i++ )
	{
		CString tick_str;
		CRect tmp_rect, tick_rect;

		// draw the tick for y-axis
		dc_plot.MoveTo( plotRect.left -12, plotRect.bottom -5 - (i*y_intv) );
		dc_plot.LineTo( plotRect.left -3, plotRect.bottom -5 - (i*y_intv) );

		tick_str.Format( _T("0x%08X"), ( ((max_val-min_val)/y_divider) * i)+min_val );

		// calculate the rectangle for text
		dc_plot.DrawText(  tick_str, &tmp_rect, DT_CALCRECT|DT_SINGLELINE );
		tick_rect.right = plotRect.left -14;
		tick_rect.left = tick_rect.right - tmp_rect.Width();
		tick_rect.top = plotRect.bottom -5 - (i*y_intv) - tmp_rect.Height()/2;
		tick_rect.bottom = tick_rect.top + tmp_rect.Height();

		// draw the text 
		dc_plot.DrawText( tick_str, &tick_rect, DT_SINGLELINE|DT_RIGHT );
	}

	// draw the minor_tick for Y axises
	dc_plot.SelectObject(&minor_tick);
	for( i=0; i< y_divider; i++ )
	{
		dc_plot.MoveTo( plotRect.left -9, plotRect.bottom -5 - (i*y_intv) - y_intv/2 );
		dc_plot.LineTo( plotRect.left -4, plotRect.bottom -5 - (i*y_intv) - y_intv/2 );
	}

	dc_plot.SetTextColor( oldColor );	
	dc_plot.SetBkMode( oldMode );

	dc_plot.SelectObject( oldPen );
}

void CD64HDblBufWaveDlg::display_buffer_data(U32 *pBuf)
{
	CClientDC dc_plot(this);
	int nDraw_Bottom; 

	int newY, oldY = -1;
	int newX, oldX = -1;
	U32 index, di_data;
	U32 dwDISamples = (m_dwDISamples/2);

	nDraw_Bottom = ( plotRect.bottom - 5 );
	dc_plot.SelectObject( &GreenPen );

	for( index=0; index<dwDISamples; index++ )
	{
		di_data = pBuf[index];

		newY = (int)( nDraw_Bottom - (n_PlotHeight * ((double)di_data/0xffffffff) ) );
		newX = (int)( index*n_PlotWidth/dwDISamples + plotRect.left );

		if ( index == 0 ) 
		{
			dc_plot.MoveTo( newX, newY );
		}
		else
		{
			dc_plot.MoveTo( oldX, oldY );
		}

		dc_plot.LineTo( newX, newY );
		oldX = newX; oldY = newY;
	}
}

void CD64HDblBufWaveDlg::OnDestroy() 
{
	U32 count;

	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if( OnBrush != NULL )
		::DeleteObject( OnBrush );

	if( OffBrush != NULL )
		::DeleteObject( OffBrush );

	RedPen.DeleteObject();
	GreenPen.DeleteObject();

	if( m_nTimer != -1 )
	{
		KillTimer( m_nTimer );
		m_nTimer = -1;
	}

	if( m_pDIAddr != NULL )
	{
		free( m_pDIAddr );
		m_pDIAddr = NULL;
	}

	if( m_bCardID != INVALID_CARD_ID )
	{
		d64h_di_async_clear( m_bCardID, &count );
		d64h_do_async_clear( m_bCardID, &count );

		d64h_close( m_bCardID );
		m_bCardID = INVALID_CARD_ID;
	}	
}

void CD64HDblBufWaveDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
    switch ( nSBCode ) {
       case SB_LINEUP :
          m_fSampleRate += 50000.0;
          if (m_fSampleRate > 1000000.0 ) m_fSampleRate = 1000000.0;
              break;
       case SB_LINEDOWN:
          m_fSampleRate -= 50000;
          if (m_fSampleRate < 50000 ) m_fSampleRate = 50000;
              break;
    }

	SetDlgItemInt( IDC_EDIT_SAMPLE_RATE, (UINT)(m_fSampleRate/1000) );
		
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


void CD64HDblBufWaveDlg::OnCardIDSelchange() 
{
	// TODO: Add your control notification handler code here
	CString strTemp;
	int card_id;
	short nErrCode;
	U32 dwBufLen;


	int nIndex = m_cbCardID.GetCurSel();
	int nCount = m_cbCardID.GetCount();

	if ((nIndex != LB_ERR) && (nCount > 1))
	{
		m_cbCardID.GetLBText( nIndex, strTemp );
		sscanf( LPCTSTR(strTemp), "%d", &card_id );

		if( m_bCardID != (U8)card_id )
		{
			// close the opened pci-d64h
			if( m_bCardID != INVALID_CARD_ID )
			{
				d64h_close( m_bCardID );
				GetDlgItem( IDC_BT_START )->EnableWindow( FALSE );
				GetDlgItem( IDC_BT_STOP )->EnableWindow( FALSE );
				m_bCardID = INVALID_CARD_ID;
			}

			nErrCode = d64h_open( (U8)card_id );
			if( nErrCode == SUCCESS_NO_ERROR )
			{
				nErrCode = d64h_di_available_memory( (U8)card_id, &dwBufLen );
				if( nErrCode == SUCCESS_NO_ERROR )
				{
					m_dwDIBufLen = ( dwBufLen * 1024 );
				}

				m_bCardID = (U8)card_id;

				GetDlgItem( IDC_BT_START )->EnableWindow( TRUE );
				GetDlgItem( IDC_BT_STOP )->EnableWindow( TRUE );
			}

		}
	}
	
}

void CD64HDblBufWaveDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	U32 dwMemSize, dwDISamples;
	void* pMem;
	short nErrCode;
	CString strMsg;
	F64 fDOSampleRate;

	dwDISamples = GetDlgItemInt( IDC_EDIT_SAMPLE ); 

	if( ( dwDISamples * sizeof(U32) ) > m_dwDIBufLen )
	{
		AfxMessageBox( TEXT("Too much samples to be acquired") );
		return;
	}
	else
	{
		if( dwDISamples != m_dwDISamples )
		{
			if( m_pDIAddr != NULL )
			{
				free( m_pDIAddr );
				m_pDIAddr = NULL;
			}
			m_dwDISamples = dwDISamples;
		}

	}


#ifdef _SELF_OUTPUT_
	nErrCode = d64h_do_config( m_bCardID, TRIG_SOURCE_INT_PACER, OREQ_DISABLE, OTRIG_HIGH );
	if( nErrCode != SUCCESS_NO_ERROR )
	{
		strMsg.Format( TEXT("d64h_do_config() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
	}
#endif

    nErrCode = d64h_di_config( m_bCardID, TRIG_SOURCE_INT_PACER, DI_NOWAITING, DI_TRIG_RISING, IREQ_FALLING );
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_di_config() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
    }

	// enable DI double-buffer mode
    nErrCode = d64h_di_async_dblbuf_mode( m_bCardID, DOUBLE_BUFFER_MODE_ENABLE );
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_di_async_dblbuf_mode() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
    }

	// disable DO double-buffer mode
    nErrCode = d64h_do_async_dblbuf_mode( m_bCardID, DOUBLE_BUFFER_MODE_ENABLE );
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_do_async_dblbuf_mode() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
		
    }

	dwMemSize = (m_dwDISamples * 2); // (m_dwDISamples * sizeof(U32)/2 )
	pMem = malloc( dwMemSize );
	if( pMem == NULL )
	{
		AfxMessageBox( TEXT("Memory allocated failed") );
		return;
	}
	else
	{
		m_pDIAddr = (U32*) pMem;
		memset( m_pDIAddr, '\0', dwMemSize );
	}

#ifdef _SELF_OUTPUT_
	fDOSampleRate = 100000.0;

	nErrCode = d64h_continue_writeport( m_bCardID, DoBuf, 10240, PARAMETER_IGNORED, &fDOSampleRate, ASYNCH_OP);
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_conti_writeport() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
    }

#endif

    nErrCode = d64h_continue_readport(m_bCardID, m_pDIAddr, m_dwDISamples, &m_fSampleRate, ASYNCH_OP);
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_conti_readport() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
    }

	// start timer
	if( m_nTimer == -1 )
	{
		m_nTimer = SetTimer( D64H_HALF_BUFFER_CHECK_TIMER, 5, NULL );
	}

	GetDlgItem( IDC_BT_START )->EnableWindow( FALSE );
	GetDlgItem( IDC_BT_STOP )->EnableWindow( TRUE );	
}

void CD64HDblBufWaveDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	U32 count;
	short nErrCode;
	CString strMsg;
	
    nErrCode = d64h_di_async_clear( m_bCardID, &count );
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_di_async_clear() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
    }

#ifdef _SELF_OUTPUT_
    nErrCode = d64h_do_async_clear( m_bCardID, &count );
	if( nErrCode != SUCCESS_NO_ERROR ) 
    {
		strMsg.Format( TEXT("d64h_do_async_clear() failed, error code = %d") ,nErrCode );
		AfxMessageBox( strMsg );
		return;
    }
#endif

	// disable Timer
	if( m_nTimer != -1 )
	{
		KillTimer( m_nTimer );
		m_nTimer = -1;
	}

	GetDlgItem( IDC_BT_START )->EnableWindow( TRUE );
	GetDlgItem( IDC_BT_STOP )->EnableWindow( TRUE );	
}

void CD64HDblBufWaveDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	BOOLEAN bHalfReady;
	short nErrCode;

	bHalfReady = FALSE;
	nErrCode = d64h_di_async_dblbuf_halfready( m_bCardID, &bHalfReady );

	if( bHalfReady == TRUE )
	{
		nErrCode = d64h_di_async_dblbuf_transfer( m_bCardID, m_pDIAddr );
		redraw_display_area();
		display_buffer_data( m_pDIAddr );
	}
	
	CDialog::OnTimer(nIDEvent);
}
